#include "Peripheral_management.h" // импортируем класс для работы с устройсвами
#include <iarduino_RTC.h> // импортируем биб. для часов реального времени
#include <EEPROM.h> // импортируем биб. для работы с EEPROM памятью
iarduino_RTC time(RTC_DS1307); // указывааем модель часов
unsigned long timing; // создаем переменую timing для использования в таймере 
int led = 4; // порт для реле к свет. ленте
int real_time; // переменая для хранения часа
int sensor = 0; // порт для подключения датчика влажности почвы
int sensor_avalue; // показатель датчика

PUMP pump(3, 0, 0, 300); // создания объекта класса pump и использованиия функции конструктора класса

void shine_on(){ // функция для включения реле для свет. ленте
  digitalWrite(led, HIGH);
}

void shine_off(){ // функция для выключения реле для свет. ленте
  digitalWrite(led, LOW);
}

int rtc(){ // функция для получения реального времени(часа)
  real_time = time.gettime("H");
  return real_time;
}

void setup(){
  pinMode(led, OUTPUT); // иницилизируем порт, как выход
  Serial.begin(9600); // включения и иницилизация serial port
  time.begin(); // иницилизация функции часов реального времени
  pump.set_Time(300); // установление времени полива
}

void set_data(int place, byte number){ // установление числа в ячейку
  EEPROM.update(place, number); 
}
int get_data(int place, byte number){ //чтение числа в ячейку
  return EEPROM.read(place); 
} 

void loop(){
  if (millis() - timing > 28800000){ // таймер на 8 часов
    timing = millis();
    sensor_avalue=analogRead(sensor); // чтение аналогового значения с датчика влажности почвы
    Serial.print(sensor_avalue); // вывод показателей в консоль для отладки
      if (sensor_avalue < 300){ // если значения датчика меньшя 300(сухая почва)
       pump.sway(); // вызов функции sway из класса
  }
  if (rtc < 19 and rtc > 7){ // если время от 8 часов до 20, то 
    shine_on(); // вызов функции включения ленты
  }else{
    shine_off(); // вызов функции выключения ленты
    }
  }
}

 #pragma once
#include <Wire.h>                        
#include <TimeLib.h>
//импорт всех библиотек

class PUMP { // создания класса
  public:
  PUMP(int nRelayDrive, int sensor, int sensor_avalue, int time_for_water){ // создания функции конструктура
    nRelayDrive = nRelayDrive;
    sensor = sensor;
    sensor_avalue = sensor_avalue;
    time_for_water = time_for_water;
    pinMode(nRelayDrive, OUTPUT);
    // определения переменых
  }
  void set_Time(int time_for_water){ // функция чтобы менять время полива во время программы
    time_for_water = time_for_water;
  }
    void sway(){
    sensor_avalue=analogRead(sensor);
      Serial.print(sensor_avalue);
      digitalWrite(nRelayDrive, HIGH); // включаем реле
      delay(time_for_water);
      digitalWrite(nRelayDrive, LOW);
    //функция для включения реле для включения помпы
    }
  private:
    int nRelayDrive = 3 ; // пин 3 у нас для управления реле
    int sensor = 0;
    int sensor_avalue;
    int time_for_water;
};